#include<stdio.h>

/*
  
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_errno.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_precision.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_math.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_linalg.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_block.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_vector.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_matrix.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_multiroots.h"

**/

#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_errno.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_precision.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_math.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_linalg.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_block.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_vector.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_matrix.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_multiroots.h"

/* #include "/home/frutos/glut-3.7/include/GL/glut.h" */

#include "functions.c" 

void roots(VEC x_init, int i, int color); 
void roots2(double xinit, double yinit, int i, int color);
void roots3(VEC x_init, int i, int color, double rad); 
void root_finder(double swept, double *x);
int  print_state(size_t iter, gsl_multiroot_fsolver *s);
void glens_roots(double *x);
int  quadrant(double x, double y);
void selection(double x, double y, double v, double w, int i);
void selection2();
void set_eq(double x, double y, int i);
void mouse(int button, int state, int x, int y);
void keyboard(unsigned char key, int x, int y);
void assign(double *x);
void order(double *p, double *q);
void bubble(double *a, int n);
void equals(double *a, int n);

int print_state(size_t iter, gsl_multiroot_fsolver *s)
{
  printf("iter = %3u x = (%10.3f, %10.3f) f(x) = (%0.3e, %0.3e) \n", iter,
         gsl_vector_get(s->x, 0), gsl_vector_get(s->x, 1),
         gsl_vector_get(s->f, 0), gsl_vector_get(s->f, 1));

 return 0; 
}

void root_finder(double swept, double *x)
{
  int i, ir = 0;

  VEC x_init;
  
  double dxi = swept;
  double dxf, dyf;
  double xf  = BOUND;  

  /* assign(x); */
    
  switch(SWEPT) {
  case 1:
    for(dxf = - xf; dxf <= xf; dxf += dxi) {      
      x_init[0] = dxf; 
      x_init[1] = 0.0;
    
      roots(x_init, ir, 4);

      /*

      printf("x[%d] = %g, y[%d] = %g\n", ir, root_x[ir], ir, root_y[ir]);
      printf("xl[%d] = %g, yl[%d] = %g\n", ir, Y_x[ir], ir, Y_y[ir]); 

      **/

      ir +=1;
    }

    /* for(dyf = - xf, dyf != 0.0; dyf <= xf; dyf += dxi) { */

    for(dyf = - xf; dyf <= xf; dyf += dxi) { 
      x_init[0] = 0.0; 
      x_init[1] = dyf;
    
      roots(x_init, ir, 4);

      /*
        
      printf("x[%d] = %g, y[%d] = %g\n", ir, root_x[ir], ir, root_y[ir]); 
      printf("xl[%d] = %g, yl[%d] = %g\n", ir, Y_x[ir], ir, Y_y[ir]); 

      **/
      
      ir +=1;          
    }
    
    /* selection2(); */

    break;
  case 2:
    for(dxf = - xf; dxf <= xf; dxf += dxi) {
      for(dyf = - xf; dyf <= xf; dyf += dxi) {    
        x_init[0] = dxf; 
        x_init[1] = dyf;
    
        roots(x_init, ir, 4);        

        /*
          
        quadrant(root_x[ir], root_y[ir]);

        set_eq(root_x[ir], root_y[ir], ir);

        **/

        printf("x[%d] = %g, y[%d] = %g\n", ir, root_x[ir], ir, root_y[ir]); 
        printf("xl[%d] = %g, yl[%d] = %g\n", ir, Y_x[ir], ir, Y_y[ir]); 
        
        ir +=1;
      }     
    }  

    /*
      
    for(i = 0; i < N_params; i++) {
      bubble(root_x, N_params);

      printf("Root_x[%d] = %g\n", i, root_x[i]);
    }

    equals(root_x, N_params);

    **/
    
    break;
  case 3:
    for(i = 0; i < Number_of_roots; i++) {    
      roots2(Xr[i][0], Xr[i][1], i, 4);

      /*
        
      printf("x[%d] = %g, y[%d] = %g\n", i, root_x[i], i, root_y[i]);
      printf("xl[%d] = %g, yl[%d] = %g\n", i, Y_x[i], i, Y_y[i]);

      **/
    }

    break;
  }

  /* draw_point(root_x[ir], root_y[ir], 5.0); */     
}

void roots(VEC x_init, int i, int color)
{
  double xr0, xr1;

  const gsl_multiroot_fsolver_type *T;

  gsl_multiroot_fsolver *s;

  gsl_multiroot_function Func; 

  /* It doesn't work */

  /* gsl_vector *x; */

  int status;
  size_t iter = 0;
  const size_t n = 2;

  gsl_vector *x = gsl_vector_alloc(n); 

  /* It doesn't work */       
  
  /* gsl_multiroot_function Func = {&chang_refsdal_f, n, 0}; */

  char *string = "success";

  /*
    
  string1 = "jacobian evaluations are not improving the solution";
  string2 = "iteration is not making progress towards solution";

  **/

  /* It works with or without &function name */
    
  switch(current_model) {
  case M_CHANG_REFSDAL:
    Func.f = &chang_refsdal_f; 
    break;   
  case M_SING_ISOT_SPHERE:
    Func.f = &singular_isothermal_sphere_f; 
    break;
  case M_NSING_ISOT_SPHERE:
    Func.f = &nonsingular_isothermal_sphere_f;
    break;
  case M_TRANSP_SPHERE:
    Func.f = &transparent_sphere_f;
    break;
  case M_ELLIPTICAL:
    Func.f = &elliptical_f;       
    break;
  case M_KING:
    Func.f = &king_f;
    break;
  case M_TRUNC_KING:
    Func.f = &truncated_king_f;
    break;
  case M_HUBBLE:
    Func.f = &hubble_f;
    break;
  case M_DE_VAUCOULEUR:
    Func.f = &de_vaucouleur_f;
    break;
  case M_SPIRAL:
    Func.f = &spiral_f;    
    break;
  case M_MULTIPOLE:
    Func.f = &multipole_f;
    break;
  case M_ROTATION_LENS:
    Func.f = &rotation_lens_f;
    break;
  case M_DOUBLE_LENS:
    Func.f = &double_lens_f;
    break;
  case M_UNIFORM_RING:
    Func.f = &uniform_ring_f;
    break; 
  }

  Func.n = 2;
  Func.params = 0; 

  gsl_vector_set(x, 0, x_init[0]);
  gsl_vector_set(x, 1, x_init[1]);

  T = gsl_multiroot_fsolver_hybrids;

  /* This is for gsl-0.7 */
  
  /* s = gsl_multiroot_fsolver_alloc(T, &Func, x); */

  /* This is for gsl-1.0 */ 
    
  s = gsl_multiroot_fsolver_alloc(T, n); 

  /* This is for gsl-1.0 */
  
  gsl_multiroot_fsolver_set(s, &Func, x);
  
  /* print_state(iter, s); */

  do {
    iter++;
    
    status = gsl_multiroot_fsolver_iterate(s);

    /* print_state(iter, s); */

    /* Check if the solver is stuck */
    
    if(status) 
      break;
    
    status = gsl_multiroot_test_residual(s->f, TOL);     
  } while(status == GSL_CONTINUE && iter < IT);

  xr0 = gsl_vector_get(s->x, 0);
  xr1 = gsl_vector_get(s->x, 1);

  /* status = success */

  /* printf("status = %s\n", gsl_strerror(status)); */

  if(strlen(string) == strlen(gsl_strerror(status))) {    
    draw_point(xr0, xr1, 5.0, color); 

    root_x[i] = xr0;
    root_y[i] = xr1;

    /*
      
    Y_x[i] = x_l;
    Y_y[i] = y_l;

    **/
    
    /* print_state(iter, s); */
  }
  
  gsl_multiroot_fsolver_free(s);
  gsl_vector_free(x);    
}

void roots2(double xinit, double yinit, int i, int color)
{
  double xr0, xr1;
  
  const gsl_multiroot_fsolver_type *T;

  gsl_multiroot_fsolver *s;

  gsl_multiroot_function Func; 

  /* It doesn't work */

  /* gsl_vector *x; */

  int status;
  size_t iter = 0;
  const size_t n = 2;

  gsl_vector *x = gsl_vector_alloc(n); 

  /* It doesn't work */       
  
  /* gsl_multiroot_function Func = {&chang_refsdal_f, n, 0}; */

  char *string = "success";

  /*
    
  string1 = "jacobian evaluations are not improving the solution";
  string2 = "iteration is not making progress towards solution";

  **/

  /* It works with or without &function name */
    
  switch(current_model) {
  case M_CHANG_REFSDAL:
    Func.f = &chang_refsdal_f; 
    break;   
  case M_SING_ISOT_SPHERE:
    Func.f = &singular_isothermal_sphere_f; 
    break;
  case M_NSING_ISOT_SPHERE:
    Func.f = &nonsingular_isothermal_sphere_f;
    break;
  case M_TRANSP_SPHERE:
    Func.f = &transparent_sphere_f;
    break;
  case M_ELLIPTICAL:
    Func.f = &elliptical_f;       
    break;
  case M_KING:
    Func.f = &king_f;
    break;
  case M_TRUNC_KING:
    Func.f = &truncated_king_f;
    break;
  case M_HUBBLE:
    Func.f = &hubble_f;
    break;
  case M_DE_VAUCOULEUR:
    Func.f = &de_vaucouleur_f;
    break;
  case M_SPIRAL:
    Func.f = &spiral_f;    
    break;
  case M_MULTIPOLE:
    Func.f = &multipole_f;
    break;
  case M_ROTATION_LENS:
    Func.f = &rotation_lens_f;
    break;
  case M_DOUBLE_LENS:
    Func.f = &double_lens_f;
    break;
  case M_UNIFORM_RING:
    Func.f = &uniform_ring_f;
    break; 
  }

  Func.n = 2;
  Func.params = 0; 
  
  gsl_vector_set(x, 0, xinit);
  gsl_vector_set(x, 1, yinit);
  
  T = gsl_multiroot_fsolver_hybrids;

  /* This is for gsl-0.7 */
  
  /* s = gsl_multiroot_fsolver_alloc(T, &Func, x); */

  /* This is for gsl-1.0 */ 
    
  s = gsl_multiroot_fsolver_alloc(T, n); 

  /* This is for gsl-1.0 */
  
  gsl_multiroot_fsolver_set(s, &Func, x);
  
  /* print_state(iter, s); */

  do {
    iter++;
    
    status = gsl_multiroot_fsolver_iterate(s);

    /* print_state(iter, s); */

    /* Check if the solver is stuck */
    
    if(status) 
      break;

    status = gsl_multiroot_test_residual(s->f, TOL);       
  } while(status == GSL_CONTINUE && iter < IT);

  xr0 = gsl_vector_get(s->x, 0);
  xr1 = gsl_vector_get(s->x, 1);

  /* status = success */

  /* printf("status = %s\n", gsl_strerror(status)); */

  if(strlen(string) == strlen(gsl_strerror(status))) {    
    draw_point(xr0, xr1, 5.0, color); 

    root_x[i] = xr0;
    root_y[i] = xr1;

    /*
      
    Y_x[i] = x_l;
    Y_y[i] = y_l;

    **/
    
    /* printf("x[%d] = %g, y[%d] = %g\n", i, xr0, i, xr1); */

    /* print_state(iter, s); */
  }
  
  gsl_multiroot_fsolver_free(s);
  gsl_vector_free(x);    
}       

void roots3(VEC x_init, int i, int color, double rad)
{
  double xr0, xr1;

  const gsl_multiroot_fsolver_type *T;

  gsl_multiroot_fsolver *s;

  gsl_multiroot_function Func; 

  /* It doesn't work */

  /* gsl_vector *x; */

  int status;
  size_t iter = 0;
  const size_t n = 2;

  gsl_vector *x = gsl_vector_alloc(n); 

  /* It doesn't work */       
  
  /* gsl_multiroot_function Func = {&chang_refsdal_f, n, 0}; */

  char *string = "success";

  /*
    
  string1 = "jacobian evaluations are not improving the solution";
  string2 = "iteration is not making progress towards solution";

  **/

  /* It works with or without &function name */
    
  switch(current_model) {
  case M_CHANG_REFSDAL:
    Func.f = &chang_refsdal_f; 
    break;   
  case M_SING_ISOT_SPHERE:
    Func.f = &singular_isothermal_sphere_f; 
    break;
  case M_NSING_ISOT_SPHERE:
    Func.f = &nonsingular_isothermal_sphere_f;
    break;
  case M_TRANSP_SPHERE:
    Func.f = &transparent_sphere_f;
    break;
  case M_ELLIPTICAL:
    Func.f = &elliptical_f;       
    break;
  case M_KING:
    Func.f = &king_f;
    break;
  case M_TRUNC_KING:
    Func.f = &truncated_king_f;
    break;
  case M_HUBBLE:
    Func.f = &hubble_f;
    break;
  case M_DE_VAUCOULEUR:
    Func.f = &de_vaucouleur_f;
    break;
  case M_SPIRAL:
    Func.f = &spiral_f;    
    break;
  case M_MULTIPOLE:
    Func.f = &multipole_f;
    break;
  case M_ROTATION_LENS:
    Func.f = &rotation_lens_f;
    break;
  case M_DOUBLE_LENS:
    Func.f = &double_lens_f;
    break;
  case M_UNIFORM_RING:
    Func.f = &uniform_ring_f;
    break; 
  }

  Func.n = 2;
  Func.params = 0; 

  gsl_vector_set(x, 0, x_init[0]);
  gsl_vector_set(x, 1, x_init[1]);

  T = gsl_multiroot_fsolver_hybrids;

  /* This is for gsl-0.7 */
  
  /* s = gsl_multiroot_fsolver_alloc(T, &Func, x); */

  /* This is for gsl-1.0 */ 
    
  s = gsl_multiroot_fsolver_alloc(T, n); 

  /* This is for gsl-1.0 */
  
  gsl_multiroot_fsolver_set(s, &Func, x);
  
  /* print_state(iter, s); */

  do {
    iter++;
    
    status = gsl_multiroot_fsolver_iterate(s);

    // print_state(iter, s); 

    /* Check if the solver is stuck */
    
    if(status) 
      break;
    
    status = gsl_multiroot_test_residual(s->f, TOL);     
  } while(status == GSL_CONTINUE && iter < IT);

  xr0 = gsl_vector_get(s->x, 0);
  xr1 = gsl_vector_get(s->x, 1);

  /* status = success */

  /* printf("status = %s\n", gsl_strerror(status)); */

  if(strlen(string) == strlen(gsl_strerror(status))) {    
    draw_point(xr0, xr1, rad, color); 

    root_x[i] = xr0;
    root_y[i] = xr1;

    /*
      
    Y_x[i] = x_l;
    Y_y[i] = y_l;

    **/
    
    // print_state(iter, s); 
  }
  
  gsl_multiroot_fsolver_free(s);
  gsl_vector_free(x);    
}

void glens_roots(double *x)
{
  int i;

  /* assign(x); */
  
  for(i = 0; i < Number_of_roots; i++) {      
    roots2(Xr[i][0], Xr[i][1], i, 4);
    
    Xr[i][0] = root_x[i];     
    Xr[i][1] = root_y[i];   

    /* printf("x[%d] = %g, y[%d] = %g\n", i, root_x[i], i, root_y[i]); */
  }

  /*
  
  switch(quadrant(root_x[i], root_y[i])) {
  case 1:
    break;
  case 2: 
    break;
  case 3:
    break;
  case 4:
    break;
  }

  **/
}

int quadrant(double x, double y)
{
  int quad;

  if(sign(x) == 1 && sign(y) == 1) {
    /* First quadrant */

    quad = 1;
  } else if(sign(x) == - 1 && sign(y) == 1) {
    /* Second quadrant */

    quad = 2;
  } else if(sign(x) == - 1 && sign(y) == - 1) {
    /* Third quadrant */

    quad = 3;
  } else {
    /* Fourth quadrant */

    quad = 4;
  }

  return quad;
}

void selection(double x, double y, double v, double w, int i)
{
  int k1, k2;
  double dist1, dist2;

  dist1 = x * x + y * y;
  dist2 = v * v + w * w;

  k1 = quadrant(x, y);
  k2 = quadrant(v, w);

  if(x != v) {
    troot_x[i] = v;
    troot_y[i] = w;
  }
}

void set_eq(double x, double y, int i)
{  
  if(fabs(x) < TOL2) {    
    x = 0.0;
  }
  
  if(fabs(y) < TOL2) {    
    y = 0.0;
  }
  
  root_x[i] = x;
  root_y[i] = y;
}

void selection2()
{
  int i, k, j = 0;

  troot_x[j] = root_x[0];
  troot_y[j] = root_y[0];
  
  for(i = 0; i < 9; i++) {
    for(k = 1; k < 9; k++) {
      if(root_x[i] != root_x[k]) {
        j += 1;

        troot_x[j] = root_x[k];
        troot_y[j] = root_y[k];

        printf("X[%d] = %g Y[%d] = %g\n", j, troot_x[j], j, troot_y[j]);
      }
    }
  }
}

void bubble(double *a, int n)
{
 int i, j;

 for(i = 0; i < n - 1; ++i) {
   for(j = n - 1; i < j; --j) {
     order(&a[j - 1], &a[j]);
   }  
 }
}

void order(double *p, double *q)
{
  double temp;

  if(*p > * q) { 
    temp = *p;
    
    *p = *q;

    *q = temp;
  }  
}

void equals(double *a, int n)
{
 int i, j = 0, h = 1, t, flag;

 double b[N_pr], ap[N_pr];

 for(i = 0; i < n; i++) {
   b[i]  = 0.0;
   ap[i] = a[i];
 }

 b[0]  = a[0];
 b[n]  = 0.0;
 ap[n] = Mil;
 
 for(i = n + 1; i < N_pr; i++) {
   b[i]  = 0.0;
   ap[i] = 0.0;
 }
   
 for(t = 0; t <= n - 2; t++) {
   j = t;
    
   flag = 0;

   do {
     j += 1;

     if(j == n - 1) {
       flag = 1;
     }

     if(ap[t] != ap[j] && flag == 0) {
       b[h] = ap[j];

       h += 1;
       
       flag = 1;       

       t = j - 1;
     } else {
       b[h] = ap[j];
     }      
   } while(flag == 0);
 }

 /*
   
 for(j = 0; j < n; j++) {
   printf("a[%d] = %g\n", j, ap[j]);
 }
 
 **/
 
 for(j = 0; j <= h - 1; j++) {
   troot_x[j] = b[j];
     
   printf("b[%d] = %g\n", j, b[j]);   
 } 
}
     
void mouse(int button, int state, int x, int y)
{
  /* Now, they do exist:
     GLUT_LEFT_BUTTON, GLUT_MIDDLE_BUTTON, GLUT_RIGHT_BUTTON */

  /* It doesn't exist: AUX_LEFTBUTTON, AUX_MIDDLEBUTTON, AUX_RIGHTBUTTON */

  switch(button) {
  case FL_LEFT_MOUSE: 
    printf("Left Mouse \n");
    break;
  case FL_MIDDLE_MOUSE:
    printf("Middle Mouse \n");
    break;
  case FL_RIGHT_MOUSE:
    printf("Right Mouse \n");
    break;
  }

  /*

  switch(button) {
    case GLUT_LEFT_BUTTON:
      if(state == GLUT_DOWN) {
        printf("Left Mouse \n");
      }
    break;
  case GLUT_MIDDLE_BUTTON:
    if(state == GLUT_DOWN) {
      printf("Middle Mouse \n");
    }
    break;
  case GLUT_RIGHT_BUTTON:
    if(state == GLUT_DOWN) {
      printf("Right Mouse \n");
    }
    break;
  }

  **/
}

void keyboard(unsigned char key, int x, int y)
{
  switch(key) {
  case 27:      
    exit (0);
    break;
  }
}

/*
  
void assign(double *x)
{
  int i;
  
  switch(SIM_AN) {
  case FALSE:
    break;
  case TRUE:
    if(sl_1 == FALSE) {
      Y[0] = x[0];        
    }

    if(sl_2 == FALSE) {
      Y[1] = x[1];        
    }

    if(sl_3 == FALSE) {
      parms[P_E] = x[2];        
    }

    if(sl_4 == FALSE) {
      parms[P_THETA] = (M_PI * x[3]) / 180.0;        
    }

    if(sl_5 == FALSE) {
      parms[P_GAMMA] = x[4];        
    }

    if(sl_6 == FALSE) {
      parms[P_SIGMA] = x[5];        
    }

    if(sl_7 == FALSE) {
      parms[P_PHI] = (M_PI * x[6]) / 180.0;        
    }

    R_E2 = parms[P_E] * parms[P_E];

    cs = cos(parms[P_THETA]);
    ss = sin(parms[P_THETA]);

    A1 = 1.0 - parms[P_SIGMA] - parms[P_GAMMA] * cos(parms[P_PHI]);
    A2 = 1.0 - parms[P_SIGMA] + parms[P_GAMMA] * cos(parms[P_PHI]);
    D  =                      - parms[P_GAMMA] * sin(parms[P_PHI]);

    switch(current_model) {
    case M_CHANG_REFSDAL:
      break;   
    case M_SING_ISOT_SPHERE:
      if(sl_25 == FALSE) {
        parms[P_EXP] = x[7];        
      }

      break;
    case M_NSING_ISOT_SPHERE:
      if(sl_8 == FALSE) {
        parms[P_KAPPA] = x[7];        
      }

      if(sl_10 == FALSE) {
        parms[P_C] = x[8];

        xc  = parms[P_C] / parms[P_E];
        xc2 = xc * xc;
      }

      break;
    case M_TRANSP_SPHERE:
      if(sl_10 == FALSE) {
        parms[P_C] = x[7];

        R_C2 = parms[P_C] * parms[P_C];
      }

      break;
    case M_ELLIPTICAL:
      if(sl_8 == FALSE) {
        parms[P_KAPPA] = x[7];        
      }

      if(sl_23 == FALSE) {
        parms[P_ALPHA] = x[8];        
      }

      if(sl_9 == FALSE) {
        parms[P_EPSILON] = x[9];        
      }

      if(sl_10 == FALSE) {
        parms[P_C] = x[10];

        xc  = parms[P_C] / parms[P_E];
        xc2 = xc * xc;
      }

      break;
    case M_KING:
      if(sl_8 == FALSE) {
        parms[P_KAPPA] = x[7];       
      }
      
      break;
    case M_TRUNC_KING:
      if(sl_26 == FALSE) {
        parms[P_KAPPA2] = x[7];        
      }

      if(sl_10 == FALSE) {
        parms[P_C] = x[8];        

        xc  = parms[P_C] / parms[P_E];
        xc2 = xc * xc;
      }
      
      break;
    case M_HUBBLE:
      if(sl_8 == FALSE) {
        parms[P_KAPPA] = x[7];       
      }
      
      break;
    case M_DE_VAUCOULEUR:
      if(sl_8 == FALSE) {
        parms[P_KAPPA] = x[7];       
      }
      
      break;
    case M_SPIRAL:
      if(sl_8 == FALSE) {
        parms[P_KAPPA] = x[7];       
      }

      if(sl_24 == FALSE) {
        parms[P_ALPHA2] = x[8];       
      } 

      break;
    case M_MULTIPOLE:
      if(sl_29 == FALSE) {
        parms[P_KAPPA0] = x[7];       
      }

      if(sl_30 == FALSE) {
        parms[P_DX_QP] = x[8];       
      }
      
      if(sl_31 == FALSE) {  
        parms[P_DY_QP] = x[9];       
      }

      if(sl_32 == FALSE) {  
        parms[P_QXX] = x[10];       
      }

      if(sl_33 == FALSE) {  
        parms[P_QXY] = x[11];       
      }

      if(sl_34 == FALSE) {  
        parms[P_QYY] = x[12];       
      }

      R_E3 = parms[P_E] * R_E2;
      R_E4 = R_E2 * R_E2;
      R_E6 = R_E2 * R_E4;
      
      break;
    case M_ROTATION_LENS:
      if(sl_21 == FALSE) {  
        parms[P_SX] = x[7];       
      }

      if(sl_22 == FALSE) {  
        parms[P_SY] = x[8];       
      }
      
      break;
    case M_DOUBLE_LENS:
      if(sl_15 == FALSE) {  
        parms[P_M_1] = x[11];       
      }

      if(sl_11 == FALSE) {  
        parms[P_X_1] = x[7];       
      }

      if(sl_12 == FALSE) {  
        parms[P_Y_1] = x[8];       
      }

      if(sl_17 == FALSE) {  
        parms[P_BETA] = x[13];       
      }

      if(sl_18 == FALSE) {  
        parms[P_GAMMA2] = x[14];       
      }

      if(sl_19 == FALSE) {  
        parms[P_SIGMA2] = x[15];       
      }

      if(sl_20 == FALSE) {  
        parms[P_PHI2] = (M_PI * x[16]) / 180.0;       
      }

      if(sl_16 == FALSE) {  
        parms[P_M_2] = x[12];       
      }

      if(sl_13 == FALSE) {  
        parms[P_X_2] = x[9];       
      }

      if(sl_14 == FALSE) {  
        parms[P_Y_2] = x[10];       
      }

      break;
    case M_UNIFORM_RING:
      if(sl_8 == FALSE) {  
        parms[P_KAPPA] = x[7];       
      }

      if(sl_27 == FALSE) {  
        parms[P_Ri] = x[8];

        Ri_E  = parms[P_Ri] / parms[P_E];
        Ri_E2 = Ri_E * Ri_E;
      }

      if(sl_28 == FALSE) {  
        parms[P_Ro] = x[9];       

        Ro_E  = parms[P_Ro] / parms[P_E];
        Ro_E2 = Ro_E * Ro_E;
      }
      
      break; 
    }   

    break;
  }

  for(i = 0; i < N_params; i++) {
    printf("params[%d] = %g\n", i, x[i]);
  }
}

**/

